function r = completeeqn(eqn, opn)

% COMPLETEEQN    Add the not appeared variables to the equation compared with the complete variables set in lm option
%
% Please see example_bn06.m.

% $Id: completeeqn.m 32 2016-08-26 05:03:35Z qihs $

if iscell(eqn),
    r = cell(size(eqn));
    for i = prod(size(eqn)):-1:1
        r{i}= completeeqn(eqn{i}, opn);
    end
    return
end
Vars = lmget(opn, 'Vars', {});
if isempty(Vars), error('Please set all variables in lm option'); end

vars = str_split(eqn);
l = length(vars);
f = zeros(1,l);
for i = 1:l, f(i) = ~islmvar(vars{i}); end
varstr = strvcat(vars(find(f)));

c = {};
j = 0;
% for i = Vars
% 	if isempty(strmatch(i,varstr,'exact'))
%         j = j+1;
%         c{j} = i;
%     end
% end
l = length(Vars);
for i = 1:l
	if isempty(strmatch(Vars{i},varstr,'exact'))
        j = j+1;
        c{j} = Vars{i};
    end
end

if ~isempty(c)
    r = [str_repeat('MU ',length(c)) str_join(c,' ') ' ' eqn];
else
    r = eqn;
end
